import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["input", "label", "isRequired", "providerRequired"];
import React from 'react';
import { RadioGroup } from "@blueprintjs/core/lib/esm/components/forms/radioGroup.js";
import FormGroupWrapper from '../form-group/form-group';
import propsCatcher from '../props-catcher/props-catcher';

var Radio = function Radio(_ref) {
  var input = _ref.input,
      label = _ref.label,
      isRequired = _ref.isRequired,
      providerRequired = _ref.providerRequired,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(RadioGroup, _extends({
    id: input.name,
    label: label
  }, isRequired && {
    label: /*#__PURE__*/React.createElement("span", null, label, " ", providerRequired)
  }, propsCatcher(props), input, {
    selectedValue: input.value
  }));
};

var WrapperRadio = function WrapperRadio(props) {
  return /*#__PURE__*/React.createElement(FormGroupWrapper, _extends({}, props, {
    hideLabel: true,
    Component: Radio,
    component: "not-radio"
  }));
};

export default WrapperRadio;