"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.FormGroupInternal = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _formGroup = require("@blueprintjs/core/lib/cjs/components/forms/formGroup.js");

var _intent = require("@blueprintjs/core/lib/cjs/common/intent.js");

var _useFieldApi = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _blueprintContext = _interopRequireDefault(require("../blueprint-context/blueprint-context"));

var _excluded = ["meta", "validateOnMount", "helperText", "description", "hideLabel", "isReadOnly", "label", "input", "isDisabled", "isRequired", "FormGroupProps", "Component"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var FormGroupInternal = function FormGroupInternal(_ref) {
  var meta = _ref.meta,
      validateOnMount = _ref.validateOnMount,
      helperText = _ref.helperText,
      description = _ref.description,
      hideLabel = _ref.hideLabel,
      isReadOnly = _ref.isReadOnly,
      label = _ref.label,
      input = _ref.input,
      isDisabled = _ref.isDisabled,
      isRequired = _ref.isRequired,
      FormGroupProps = _ref.FormGroupProps,
      Component = _ref.Component,
      rest = (0, _objectWithoutProperties2["default"])(_ref, _excluded);

  var _useContext = (0, _react.useContext)(_blueprintContext["default"]),
      required = _useContext.required;

  var error = meta.error,
      touched = meta.touched,
      warning = meta.warning,
      submitError = meta.submitError;
  var showError = (validateOnMount || touched) && (error || submitError);
  var showWarning = (validateOnMount || touched) && warning;
  var text = showError || showWarning || helperText || description;
  var intent = showError && {
    intent: _intent.Intent.DANGER
  } || showWarning && {
    intent: _intent.Intent.WARNING
  };
  var labelInfo = !hideLabel && isRequired && {
    labelInfo: required
  };
  return /*#__PURE__*/_react["default"].createElement(_formGroup.FormGroup, (0, _extends2["default"])({
    helperText: text,
    label: !hideLabel && label,
    labelFor: input.name
  }, labelInfo, FormGroupProps, intent), /*#__PURE__*/_react["default"].createElement(Component, (0, _extends2["default"])({
    providerRequired: required,
    disabled: isDisabled || isReadOnly
  }, rest, {
    label: label,
    isRequired: isRequired,
    input: input
  }, intent)));
};

exports.FormGroupInternal = FormGroupInternal;

var FormGroupWrapper = function FormGroupWrapper(props) {
  var rest = (0, _useFieldApi["default"])(props);
  return /*#__PURE__*/_react["default"].createElement(FormGroupInternal, rest);
};

var _default = FormGroupWrapper;
exports["default"] = _default;